newImage("ZellkernSimulation", "RGB White", 1232, 786, 1);

pathfile=File.openDialog("Choose the file to Open:"); 
filestring=File.openAsString(pathfile); 
rows=split(filestring, "\n"); 
x=newArray(rows.length); 
y=newArray(rows.length); 
al=newArray(rows.length); 
ak=newArray(rows.length); 
w=newArray(rows.length); 
m=newArray(rows.length); 
st=newArray(rows.length);
wz=newArray(rows.length);

for(i=1; i<rows.length; i++){ 

columns=split(rows[i],"\t"); 
x[i]=parseInt(columns[7]); 
y[i]=parseInt(columns[8]); 
al[i]=parseInt(columns[16]); 
ak[i]=parseInt(columns[17]); 
w[i]=parseInt(columns[18]);
m[i]=parseInt(columns[2]); 
st[i]=parseInt(columns[3]); 

drawEllipse(x[i], y[i], (al[i]/2), (ak[i]/2), w[i]); 
run("Make Binary");
run("Fill Holes");


//print(asin(ak[i]/al[i])*(180/PI));

}
//selectWindow("Log");
//saveAs("Text", "I:\\Medizinische Wissenschaften\\Dissertation\\Bilder\\Versuche\\Zellkerne\\Trichrome\\ZellkerneExtrahieren\\Versuch3 - PLOS\\ZellkernZWinkel.txt");

selectWindow("ZellkernSimulation");
run("RGB Color");
open("I:\\Medizinische Wissenschaften\\Dissertation\\Bilder\\Versuche\\Zellkerne\\Trichrome\\ZellkerneExtrahieren\\Versuch3 - PLOS\\Versuch3.jpg");
imageCalculator("Add create", "ZellkernSimulation","Versuch3.jpg");

selectWindow("ZellkernSimulation");

setOption("BlackBackground", false);
run("Make Binary");
run("Set Measurements...", "area mean standard modal min centroid center perimeter bounding fit shape area_fraction stack limit add redirect=None decimal=3");
run("Analyze Particles...", "size=10-Infinity circularity=0.00-1.00 show=[Bare Outlines] display exclude include summarize record add in_situ");
selectWindow("Result of ZellkernSimulation");
roiManager("Show All with labels");
roiManager("Show All");
saveAs("Results", "I:\\Medizinische Wissenschaften\\Dissertation\\Bilder\\Versuche\\Zellkerne\\Trichrome\\ZellkerneExtrahieren\\Versuch3 - PLOS\\ResultsVersuch3Final.txt");

selectWindow("ZellkernSimulation");
saveAs("Jpeg", "I:\\Medizinische Wissenschaften\\Dissertation\\Bilder\\Versuche\\Zellkerne\\Trichrome\\ZellkerneExtrahieren\\Versuch3 - PLOS\\Versuch3SegmentierteKerne.jpg");
exit;

requires("1.42i");
  if (selectionType==-1)
      exit("Area selection required");
  List.setMeasurements;
  //print(List.getList); // list all measurements
  x = List.getValue("X");
  y = List.getValue("Y");
  a = List.getValue("Major");
  b = List.getValue("Minor");
  angle = List.getValue("Angle");
  getVoxelSize(w, h, d, unit);
  drawEllipse(x/w, y/w, (a/w)/2, (b/w)/2, angle);
  exit;

  function drawEllipse(x, y, a, b, angle) {
      autoUpdate(false);
      setLineWidth(2);
      beta = -angle * (PI/180);
      for (i=0; i<=360; i+=2) {
          alpha = i*(PI/180) ;
          X = x + a*cos(alpha)*cos(beta) - b*sin(alpha)*sin(beta);
          Y = y + a*cos(alpha)*sin(beta) + b*sin(alpha)*cos(beta);
          if (i==0) moveTo(X, Y); else lineTo(X,Y);
          if (i==0) {ax1=X; ay1=Y;}
          if (i==90) {bx1=X; by1=Y;}
          if (i==180) {ax2=X; ay2=Y;}
          if (i==270) {bx2=X; by2=Y;}
      }
      drawLine(ax1, ay1, ax2, ay2);
      drawLine(bx1, by1, bx2, by2);
      updateDisplay;
  }




